﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Zeiterfassung
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            kalender.SelectedDate = DateTime.Today;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            string anrede = "Sehr geehrte Frau";
            if(radioM.IsChecked == true)
            {
                anrede = "Sehr geehrter Herr";
            }

            if(radioMitarbeiter.IsChecked == true)
            {
                Mitarbeiter m = new Mitarbeiter(textBoxVorname.Text, textBoxNachname.Text, anrede, kalender.SelectedDate.Value);
                listBoxPersonen.Items.Add(m);
            }
            else if(radioGast.IsChecked == true)
            {
                if(listBoxPersonen.SelectedItem is Mitarbeiter)
                {
                    Gast g = new Gast(textBoxVorname.Text, textBoxNachname.Text, anrede, kalender.SelectedDate.Value, (Mitarbeiter)(listBoxPersonen.SelectedItem));
                    listBoxPersonen.Items.Add(g);
                }
                else
                {
                    MessageBox.Show("Kein Mitarbeiter als Gastgeber gewählt!");
                }
            }

            //Mitarbeiter m = new Mitarbeiter("edrftz", "edrftgz", "edrftz", DateTime.Today);
            //Gast g = new Gast("edrftgzhu", "edrftgzu", "ertzui", new DateTime(2000, 1, 1), m);

            //Person[] personen = new Person[10];
            //personen[0] = m;
            //personen[1] = g;
            //bool darf = personen[0].DarfBüroAlleineBetreten();
            //darf = personen[1].DarfBüroAlleineBetreten();

            //KommtGehtZeit z = new KommtGehtZeit();
            //System.Threading.Thread.Sleep(1000);
            //z.Geht();
            //TimeSpan s = z.Dauer;
        }

        private void buttonKommen_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                ((Person)listBoxPersonen.SelectedItem).Kommt();
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonGehen_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                ((Person)listBoxPersonen.SelectedItem).Geht();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonArbeitszeit_Click(object sender, RoutedEventArgs e)
        {
            if(listBoxPersonen.SelectedItem == null)
            {
                MessageBox.Show("Niemand angewählt!");
            }
            else if(listBoxPersonen.SelectedItem is Mitarbeiter)
            {
                TimeSpan dauer = ((Mitarbeiter)listBoxPersonen.SelectedItem).BerechneArbeitszeit();
                MessageBox.Show("Arbeitszeit:\n" + dauer.TotalHours + " h");
            }
            else
            {
                MessageBox.Show("Kein Mitarbeiter!");
            }
        }

        private void buttonDateiSchreiben_Click(object sender, RoutedEventArgs e)
        {
            StringBuilder text = new StringBuilder();
            // für jeden Mitarbeiter in der Listbox:
            // Nachname Arbeitszeit
            foreach (var item in listBoxPersonen.Items)
            {
                if(item is Mitarbeiter)
                {
                    Mitarbeiter m = (Mitarbeiter)item;
                    text.Append(m.Nachname);
                    text.Append(" ");
                    text.Append(m.BerechneArbeitszeit().TotalHours);
                    text.AppendLine();
                }
            }

            File.WriteAllText(@"C:\Users\jl\Desktop\zeiten.txt", text.ToString());
        }
    }
}
